<script>
import { save, show, index, destroy } from "@/api/system/baseForm";
import { CreateDialog } from "@/utils/createDialog"
import { deepCopy } from "@/utils";
import { resolveFormInfo } from '@/utils/createTable'
export default {
  props: {
    tableName: String,
  },
  render(h) {
    let dialog = new CreateDialog(this,[
      {
        key: 'landArea',
        label: '土地面积',
        render: h('span', this.row.shijimianji)
      },
      {
        key: 'houseArea',
        label: '日期',
        render: h('span', this.row.dengjishijian)
      },
      {
        key: 'tudixingzhi',
        label: '土地性质',
        render: h('span', this.row.shiyongquanleixing)
      },
      {
        key: 'tudiyongtu',
        label: '用途',
        render: h('span', this.row.yongtu)
      }
    ],{
      width: "650px"
    })
    return dialog.render()
  },
  data() {
    return {
      columns: 1,
      row: {},
      formInfo: [],
      id: "",
      type: "add",
      dialogVisible: false,
      form: {},
      originalForm: {},
      rules: {},
      file: {},
    };
  },
  methods: {
    setRow (row) {
      this.row = row
    },
    init() {
      for (let key in this.form) {
        if (this.form[key] instanceof Array) {
          this.form[key] = [];
        } else {
          this.form[key] = "";
        }
      }
      this.$refs["elForm"].clearValidate();
    },
    show() {
      this.dialogVisible = true;
    },
    hidden() {
      this.dialogVisible = false;
    },
    setType(type = "add") {
      let types = ["add", "editor", "show"];
      if (types.includes(type)) {
        this.type = type;
      } else {
        console.warn("Unknown type: " + type);
      }
    },
    setId(id) {
      if (typeof id == "number") {
        this.id = id;
      } else {
        console.error("error typeof id: " + typeof id);
      }
    },

    async getDetail() {
      const res = await show({ id: this.id, table_name: 'his_evolutions' });
      this.$integrateData(this.form, res);

      this.formInfo.forEach((i) => {
        if (i.edit_input === "file") {

        }
        if (i.edit_input === "files") {
          this.file[i.field] = res[`${i.field}_upload_details`]
        }

      });
      this.form = Object.assign({}, this.form);
      this.originalForm = deepCopy(res);
    },

    submit() {
      if (/\/house/g.test(this.$route.path)) {
        this.form['house_id'] = this.row.id
      }
      if (/\/land/g.test(this.$route.path)) {
        this.form['land_id'] = this.row.id
      }
      if (this.type === "add") {
        if (this.form.hasOwnProperty("id")) {
          delete this.form.id;
        }
      }
      if (this.type === "editor") {
        Object.defineProperty(this.form, "id", {
          value: this.id,
          enumerable: true,
          configurable: true,
          writable: true,
        });
      }
      let promiseAll = []
      this.formInfo.forEach((info) => {
        if (
          info._relations?.link_relation === "newHasMany" ||
          info._relations?.link_relation === "hasMany"
        ) {
          if (this.originalForm[info._relations.link_with_name]) {
            this.originalForm[info._relations.link_with_name].map((i) => {
              promiseAll.push(
                destroy({
                  id: i.id,
                  table_name: info._relations.link_table_name,
                })
              );
            });
          }
        }

        if (info.edit_input === "files") {
          this.form[info.field] = this.file[
            info.field
            ]?.map((i) => i?.response?.id);
        }
      })

      save(Object.assign(this.form, { table_name: 'his_evolutions' })).then(res => {
        this.$Message.success({
          content: `${this.type === "add" ? "新增" : "编辑"}成功`,
        });
        this.$emit("refresh");
        this.hidden();
      })
    },
  },
  computed: {
    title () {
      if (this.type === 'add') return '新增'
      if (this.type === 'editor') return '编辑'
      if (this.type === 'show') return '查看'
    }
  },
  watch: {
    formInfo: {
      handler: function (newVal) {
        this.form = {};
        this.rules = {};
        this.file = {};
        newVal.forEach((i) => {
          if (i.field) {
            this.form[i.field] = "";
            if (
              i.validation instanceof Array &&
              i.validation.length > 0 &&
              !!i.validation.find((i) => i === "required")
            ) {
              this.rules[i.field] = [
                { required: true, message: `请填写${i.name}` },
              ];
            }
            if (i.edit_input === "files") {
              this.form[i.field] = [];
            }
            if (i.edit_input === "files" || i.edit_input === "file") {
              this.file[i.field] = [];
            }
            if (i.edit_input === "checkbox") {
              this.form[i.field] = [];
            }
            if (i._relations) {
              this.form[i._relations?.link_with_name] = [];
            }
          }
        });

        this.columns = newVal.length > 11 ? '2' : '1'
      },
      //immediate: true,
    },
    dialogVisible(val) {
      if (val) {
        document.documentElement.style.setProperty(
          "--column-num",
          this.columns
        );
        if (this.type === "editor" || this.type === "show") {
          this.$nextTick(() => this.getDetail());
        }
      } else {
        this.id = "";
        this.type = "";
        this.init();
        this.$refs["elForm"].clearValidate();
        delete this.form.id;
        for (let key in this.file) {
          this.file[key] = [];
        }
      }
    },
  },
  created() {
     resolveFormInfo(14).then(res => this.formInfo = res)
  }
};
</script>

<style>
:root {
  --column-num: 2;
}
</style>
<style scoped lang="scss">
.uploaded-a {
  color: red;
  text-decoration: none;
  transition: all 0.2s;
}

.uploaded-a:hover {
  color: red;
  text-decoration: underline;
}

.form-body {
  display: grid;
  grid-gap: 10px;
  grid-template-columns: repeat(var(--column-num), 1fr);
}
</style>
